% Compute the max magnitude
%clear;

windowSize = 7;
downsampleDimension = 8;
NORMALIZE_IMAGE = true;
GaussianVariance = 0.5;
load downsampleMapping.mat

filePath = 'MDL-dataset/';
directoryFiles = dir(filePath);
halfWindowSize= floor(windowSize/2);
GaussianMask = torr_gauss_mask(halfWindowSize, halfWindowSize*GaussianVariance);
for fileIndex=181:length(directoryFiles)
    currentFilename = directoryFiles(fileIndex).name;
    disp(currentFilename);
    if (length(currentFilename)>4) && strcmp(currentFilename(end-3:end),'.jpg')
        % It is an image file
        imageName = currentFilename(1:end-4);
        dataFilename = [filePath imageName '.mat'];
        
        imageFullPath = [filePath currentFilename];
        image = imread(imageFullPath);
        if ~isempty(whos('image'))
            [imageX,imageY,imageDepth] = size(image);
            if NORMALIZE_IMAGE
                % Resize the image to 320*240
                imageSize = 320;
                if imageX>=imageY
                    resizedImageY = round(imageY/imageX*imageSize);
                    image = imresize(image,[imageSize,resizedImageY]);
                else
                    resizedImageX = round(imageX/imageY*imageSize);
                    image = imresize(image,[resizedImageX,imageSize]);
                end
            end
            
            % Construct texture vectors
            image = double(image);
            [imageX, imageY,channelCount] = size(image);
            sampleDimension = windowSize*windowSize*channelCount;
            for xIndex=halfWindowSize+1:imageX-halfWindowSize
                for yIndex=halfWindowSize+1:imageY-halfWindowSize
                    % Random sampling
                    if rand()<0.02
                        sampleWindow = image(xIndex-halfWindowSize:xIndex+halfWindowSize, ...
                            yIndex-halfWindowSize:yIndex+halfWindowSize,:);

                        sampleCount = sampleCount + 1;
                        for channelIndex=1:channelCount
                            sampleWindow(:,:,channelIndex) = sampleWindow(:,:,channelIndex) .* GaussianMask;
                        end
                        currentX = reshape(sampleWindow,sampleDimension,1);
                        currentX = (currentX-meanX)/normalizedMagnitude;
                        X(:,sampleCount) = currentX;
                    end
                end
            end
            
            % save SVD result
            clear S V
            pack;
            [PCAMatrix, S, V] = svds(X,downsampleDimension);
            save downsampleMapping.mat PCAMatrix -v6 -append;
        end
    end
end