% Testing script
NORMALIZE_IMAGE = true;

textureDifferenceThreshold = 0.3;
textureDifferenceMetric = 2;

filePath = 'MDL-dataset/';
directoryFiles = dir(filePath);

for fileIndex=1:length(directoryFiles)
    currentFilename = directoryFiles(fileIndex).name;
    disp(currentFilename);
    if (length(currentFilename)>4) && strcmp(currentFilename(end-3:end),'.jpg')
        % It is an image file
        imageName = currentFilename(1:end-4);
        dataFilename = [filePath imageName '.mat'];
        
        imageFullPath = [filePath currentFilename];
        image = imread(imageFullPath);
        if ~isempty(whos('image'))
            [imageX,imageY,imageDepth] = size(image);
            if NORMALIZE_IMAGE
                % Resize the image to 320*240
                imageSize = 320;
                if imageX>=imageY
                    resizedImageY = round(imageY/imageX*imageSize);
                    image = imresize(image,[imageSize,resizedImageY]);
                else
                    resizedImageX = round(imageX/imageY*imageSize);
                    image = imresize(image,[resizedImageX,imageSize]);
                end
            end

            % colorMetric 'rgb' overwrites channelCount to 3.
            % If want to use a single L channel, choose 'lab' and 1 channel.
            % If want to use u and v channels, choose 'uvl' and 2 channels.
            [pixelLabels, syntheticImage] = CTM_adaptive_segmentor(image,...
                'textureDifferenceThreshold',textureDifferenceThreshold,...
                'textureDifferenceMetric', textureDifferenceMetric, ...
                'superpixelImageFilename',dataFilename,'readSuperpixelFile',true,'readSampleLabels',false,...
                'saveSegmentationResult',true);

            syntheticImage = im2double(syntheticImage);
            boundaryImage = segImage(syntheticImage,pixelLabels);
            segmentationImageFilename = [filePath imageName '-result.png'];
            imwrite(boundaryImage,segmentationImageFilename);
        end
    end
end